-- BuildSomething_Sow
-- BuildSomething_Science
-- BuildSomething_Port
-- BuildSomething_Buy_Elixir
-- BuildSomething_Tower


BuildSomething_Sow = room {
    nam = function (s)
        p ('Год '..Year..'. Обучение.');
    end,
    pic = 'images/labour.png',
    enter = function (s)
        if not ( (Year>=3) and (not isSow) and (Corn.now>1000) ) then
            return walk (BuildSomething_Science);
        end
    end,
    dsc = function (s)
        p ('^После нескольких лет правления, Вы понимаете, что Ваши крестьяне совершенно не умеют ни пахать ни сеять.^Вы нашли опытного землевладельца. Он готов обучить Ваших людей.^Землевладелец просит за услуги 1000 бушелей зерна.');
        p ('^Зерно в Ваших амбарах: ', Corn.now, ' бушелей.');
        p ('^Обучить людей?');
    end,
    obj = { vway('1', '{Да}^', 'BuildSomething_Sow_ready'),
            vway('2', '{Нет}', 'BuildSomething_Science') },
};


BuildSomething_Sow_ready = room {
    nam = 'Обучение завершено',
    pic = 'images/labour.png',
    entered = function (s)
        Corn.deal = -1000;
        Corn.now = Corn.now + Corn.deal;
        isSow = true;
    end,
    dsc = function (s)
        return 'Теперь Ваши подданные умеют обрабатывать землю!';
    end,
    obj = { vway('1', '{Далее}^', 'BuildSomething_Science') },
};


BuildSomething_Science = room {
--    nam = 'BuildSomething_Science',
    nam = function (s)
        p ('Год '..Year..'. Строительство Королевской Академии.');
    end,
    pic = 'images/academy.png',
    enter = function (s)
        if not ( (Year>=10) and (not isScience) and (Corn.now>10000) ) then
            return walk (BuildSomething_Port);
        end
    end,
    dsc = function (s)
        p ('^Чтобы облегчить свою жизнь и так и не остаться в каменном веке, просто необходимо развивать науку. Для начала неплохо бы построить Королевскую Академию, где будут проводиться различные исследования и обучение крестьян и их детей.');
        p ('^Для постройки здания необходимо 10000 бушелей зерна.');
        p ('^Зерно в Ваших амбарах: ', Corn.now, ' бушелей.');
        p ('^Построить Академию?');
    end,
    obj = { vway('1', '{Да}^', 'BuildSomething_Science_ready'),
            vway('2', '{Нет}', 'BuildSomething_Port') },
};


BuildSomething_Science_ready = room {
    nam = 'Королевская Академия построена',
    pic = 'images/academy.png',
    entered = function (s)
        Corn.deal = -10000;
        Corn.now = Corn.now + Corn.deal;
        isScience = true;
    end,
    dsc = function (s)
        return 'Королевская Академия построена! Теперь Ваши подданные подданные смогут обучаться науке.';
    end,
    obj = { vway('1', '{Далее}^', 'BuildSomething_Port') },
};


BuildSomething_Port = room {
    nam = function (s)
        p ('Год '..Year..'. Строительство Порта.');
    end,
    pic = 'images/port.png',
    enter = function (s)
        if not ( (Year>=20) and (not isPort) and (isScience) and (Corn.now>50000) ) then
            return walk (BuildSomething_Buy_Elixir);
        end
    end,
    dsc = function (s)
        p ('^Чтобы быстрей расширять свои границы, Вам необходимо закрепить своё положение не только на суше, но и на море. Предлагается построить порт.');
        p ('^На кораблях Вы сможете нападать и грабить торговые корабли.');
        p ('^Для постройки порта необходимо 50000 бушелей зерна.');
        p ('^Зерно в Ваших амбарах: ', Corn.now, ' бушелей.');
        p ('^Построить порт?');
    end,
    obj = { vway('1', '{Да}^', 'BuildSomething_Port_ready'),
            vway('2', '{Нет}', 'BuildSomething_Buy_Elixir') },
};


BuildSomething_Port_ready = room {
    nam = 'Строительство порта завершено',
    pic = 'images/port.png',
    entered = function (s)
        Corn.deal = -50000;
        Corn.now = Corn.now + Corn.deal;
        isPort = true;
    end,
    dsc = function (s)
        return 'Порт построен! Теперь Вы можете нападать на чужие корабли.';
    end,
    obj = { vway('1', '{Далее}^', 'BuildSomething_Buy_Elixir') },
};


BuildSomething_Buy_Elixir = room {
--    nam = 'BuildSomething_Buy_Elixir',
    nam = function (s)
        p ('Год '..Year..'. Эликсир Долголетия.');
    end,
    pic = 'images/graveyard.png',
    enter = function (s)
        if not ( (Year>60) and (Corn.now >= 100000) and (not LongLife) ) then
            return walk (BuildSomething_Tower);
        end
    end,
    dsc = function (s)
        p ('У Вас уже достаточно зерна, чтобы купить Эликсир Долголетия.^Продлим жизнь? Эликсир будет стоить Вам 100000 бушелей зерна.');
        p ('^Зерно в Ваших амбарах: ', Corn.now, ' бушелей.');
        p ('^Купить Эликсир Долголетия?');
    end,
    obj = { vway('1', '{Купить эликсир}^', 'BuildSomething_Buy_Elixir_ready'),
            vway('2', '{Повременить с ответом}', 'BuildSomething_Tower') },
};


BuildSomething_Buy_Elixir_ready = room {
    nam = 'Эликсир Долголетия куплен',
    pic = 'images/main.png',
    entered = function (s)
        LongLife = true;
        Corn.deal = Corn.deal - 100000;
        Corn.now = Corn.now - 100000;
    end,
    dsc = function (s)
        return 'Вы купили Эликсир Долголетия и этим продлили себе жизнь!';
    end,
    obj = { vway('1', '{Далее}^', 'BuildSomething_Tower') },
};


BuildSomething_Tower = room {
--    nam = 'BuildSomething_Tower',
    nam = function (s)
        p ('Год '..Year..'. Строительство Башни Света.');
    end,
    pic = 'images/tower.png',
    enter = function (s)
        if ( (isTower) or not ( (Year<MegaMonster) and (Year>=85) and (Corn.now>250000) ) ) then
            return walk (main_cycle);
        end
    end,
    dsc = function (s)
        p ('Армия Тьмы наступает! Но теперь Вы не так бессильны. Беглец, которого Вы приняли у себя 5 лет назад, сообщил, что только Башня Света может снизить натиск сил Тьмы. По предварительным подсчетам на постройку Башни потребуется 250000 бушелей зерна.');
        p ('^Зерно в Ваших амбарах: ', Corn.now, ' бушелей.');
        p ('^Построить башню?');
    end,
    obj = { vway('1', '{Начать строительство}^', 'BuildSomething_Tower_ready'),
            vway('2', '{Время есть, подождём}', 'main_cycle') },
};


BuildSomething_Tower_ready = room {
    nam = 'Башня Света построена',
    pic = 'images/tower.png',
    entered = function (s)
        Corn.deal = -250000;
        Corn.now = Corn.now + Corn.deal;
        isTower = true;
    end,
    dsc = function (s)
        return 'Вы построили Башню Света.';
    end,
    obj = { vway('1', '{Далее}^', 'main_cycle') },
};

