ShowBuyLandDialog = room {
    nam = function (s)
        p ('Год '..Year..'. Покупка земли.');
    end,
    pic = 'images/dry_land.png',
    enter = function (s)
        tmp = math.random (12);
        CurrLandPrice = 22 + tmp;
        m = math.floor ((Corn.now - 50)/CurrLandPrice);
        n = math.floor ( (Corn.now - 50 - People.now*40) / CurrLandPrice );
        if (m < 0) then
            m = 0;
        end
        if (n < 0) then
            n = 0;
        end
        if (m == 0) then
            p ('^Стоимость одного акра земли: ', CurrLandPrice, ', у Вас зерна: ', Corn.now, '.^С учётом того, что надо оставить хотя бы 50 бушелей зерна людям на питание, Вы не можете купить ни одного акра земли!');
            return walk (ShowSellLandDialog);
        end
        vvod._txt = '';
        vvod:act();
    end,
    forcedsc = true;
    dsc = function (s)
        p ('^^На данный момент у Вас:');
        p ('^Зерна: ', Corn.now, ' бушелей.');
        p ('^Людей: ', People.now, ' человек.');
        p ('^Для питания людям надо: ', People.now*40, ' бушелей зерна.');
        p ('^Земли в наличии: ', Land.now, ' акров.');
        p ('^Земли требуется: ', People.now*5, ' акров.');
        p ('^С учётом зерна на питание, Вы можете купить: ', n, ' акров земли за ', n*CurrLandPrice, ' бушелей зерна.');
        p ('^Максимум Вы можете купить: ', m, ' акров земли за ', m*CurrLandPrice, ' бушелей зерна.');
        p ('^^Сколько акров земли Вы хотите купить по цене ', CurrLandPrice, ' бушель/акр ?');
    end,
    inp_enter = function()
        local a = 0;
        a = tonumber(vvod:text());
        if not a then
            p 'Ошибка - это не число.';
            vvod:act();
            return;
        end
        if (a < 0) then
            a = 0;
        end
        if (a > Corn.now) then
            p 'У Вас нет столько зерна!'
            vvod:act();
            return;
        end
        if ( ((Corn.now - a * CurrLandPrice) < 50) and (Corn.now>0) and (not(a==0)) ) then
            p 'А люди то от голода умрут!';
            vvod:act();
            return;
        end
        Corn.land = -a * CurrLandPrice;
        Land.corn = a;
        Land.now = Land.now + a;
        Corn.now = Corn.now + Corn.land;
        Statistics.land_purchased = Statistics.land_purchased + a;
        CurrLandPrice = CurrLandPrice - 1;
        tmp = math.random (10 + 40 * Science.policy);
        if (tmp < 10) then
            CurrLandPrice = CurrLandPrice - 1;
        end
        -- end of part
        return walk (ShowSellLandDialog);
    end;
--    obj = { vway('1', '{Далее}', 'ShowSellLandDialog') },
    obj = { 'vvod' },
};


ShowSellLandDialog = room {
    nam = function (s)
        p ('Год '..Year..'. Продажа земли.');
    end,
    pic = 'images/city_corn.png',
    entered = function (s)
        vvod._txt = '';
        vvod:act();
    end,
    forcedsc = true;
    dsc = function (s)
        p ('^Сколько акров земли Вы хотите продать за ', CurrLandPrice, ' бушелей/акр ?');
        p ('^^На данный момент у Вас:');
        p ('^Зерна: ', Corn.now, ' бушелей.');
        p ('^Людей: ', People.now, ' человек.');
        p ('^Для питания людям надо: ', People.now*40, ' бушелей зерна.');
        p ('^Земли в наличии: ', Land.now, ' акров.');
        p ('^Земли требуется: ', People.now*5, ' акров.');
        p ('^^Сколько акров?');
    end,
    inp_enter = function()
        local a = 0;
        a = tonumber(vvod:text());
        if not a then
            p 'Ошибка - это не число.';
            vvod:act();
            return;
        end
        if (a < 0) then
            a = 0;
        end
        if (a > Land.now) then
            p 'У Вас нет столько земли!';
            vvod:act();
            return;
        end
        if (not (a == 0)) then
            if (a > Land.now-25) then
                p 'А где Вашим людям жить?';
                vvod:act();
                return;
            end
        end
        if ( a > (1000 + Science.buy*500) ) then
            m = a;
            return walk (ShowSellLandDialog_too_much);
        end
        Land.corn = Land.corn - a;
        Land.now = Land.now - a;
        Corn.land = Corn.land + CurrLandPrice * a;
        Corn.now = Corn.now + CurrLandPrice * a;
        Statistics.land_sold = Statistics.land_sold + a;
        if ( (People.now*5)> Land.now ) then 
            Yoke = Yoke + math.floor ((20 - Science.policy)*(People.now*4/(Land.now))/3);
            p '^Народ недоволен! Слишком высокая плотность населения для такого малого количества земли!';
        end
        return walk (ShowEatDialog);
    end;
    obj = { 'vvod' },
};


ShowSellLandDialog_too_much = room {
    nam = function (s)
        p ('Год '..Year..'. Продажа земли.');
    end,
    pic = 'images/labour.png',
    dsc = function (s)
        p ('Так много Вы можете продать только за ', CurrLandPrice-1, ' бушелей/акр.');
    end,
    obj = { vway('1', '{Продаём}^', 'ShowEatDialog'),
            vway('2', '{Другое количество}', 'ShowSellLandDialog') },
    exit = function (s, to)
        if to == ShowEatDialog then
            CurrLandPrice = CurrLandPrice - 1;
            Land.now = Land.now - m;
            Land.corn = Land.corn -m;
            Corn.land = CurrLandPrice * m;
            Corn.now = Corn.now + Corn.land;
            Statistics.land_sold = Statistics.land_sold + m;
            if ( (People.now*5)> Land.now ) then 
                Yoke = Yoke + math.floor ((20 - Science.policy)*(People.now*4/(Land.now))/3);
                p '^Народ недоволен! Слишком высокая плотность населения для такого малого количества земли!';
            end
        end
    end,
};
