ShowBuyLandDialog = room {
    nam = function (s)
        p ('Year '..Year..'. Land purchasing.');
    end,
    pic = 'images/dry_land.png',
    enter = function (s)
        tmp = math.random (12);
        CurrLandPrice = 22 + tmp;
        m = math.floor ((Corn.now - 50)/CurrLandPrice);
        n = math.floor ( (Corn.now - 50 - People.now*40) / CurrLandPrice );
        if (m < 0) then
            m = 0;
        end
        if (n < 0) then
            n = 0;
        end
        if (m == 0) then
            p ('^Current land price (for 1 acre): ', CurrLandPrice, ', you have in graneries: ', Corn.now, '.^Taking into account that you have to reserve at least 50 bushels of grain to feed the people, you can not afford to buy not a single acre of land!');
            return walk (ShowSellLandDialog);
        end
        vvod._txt = '';
        vvod:act();
    end,
    forcedsc = true;
    dsc = function (s)
        p ('^^Now you have:');
        p ('^Grain: ', Corn.now, ' bushels.');
        p ('^People: ', People.now, ' man.');
        p ('^People need: ', People.now*40, ' bushels of grain for food.');
        p ('^Land in possess: ', Land.now, ' acres.');
        p ('^Land required: ', People.now*5, ' acres.');
        p ('^Taking into consideration grain you have to spend on food, you can buy: ', n, ' acres of land for ', n*CurrLandPrice, ' bushels of grain.');
        p ('^Maximum you can buy: ', m, ' acres for ', m*CurrLandPrice, ' bushels of grain.');
        p ('^^How much acres you want to buy for ', CurrLandPrice, ' bushels/acre ?');
    end,
    inp_enter = function()
        local a = 0;
        a = tonumber(vvod:text());
        if not a then
            p 'Error - this is not a number.';
            vvod:act();
            return;
        end
        if (a < 0) then
            a = 0;
        end
        if (a > Corn.now) then
            p 'You have not that much grain!'
            vvod:act();
            return;
        end
        if ( ((Corn.now - a * CurrLandPrice) < 50) and (Corn.now>0) and (not(a==0)) ) then
            p 'Your people will die for starvation!';
            vvod:act();
            return;
        end
        Corn.land = -a * CurrLandPrice;
        Land.corn = a;
        Land.now = Land.now + a;
        Corn.now = Corn.now + Corn.land;
        Statistics.land_purchased = Statistics.land_purchased + a;
        CurrLandPrice = CurrLandPrice - 1;
        tmp = math.random (10 + 40 * Science.policy);
        if (tmp < 10) then
            CurrLandPrice = CurrLandPrice - 1;
        end
        -- end of part
        return walk (ShowSellLandDialog);
    end;
--    obj = { vway('1', '{Далее}', 'ShowSellLandDialog') },
    obj = { 'vvod' },
};


ShowSellLandDialog = room {
    nam = function (s)
        p ('Year '..Year..'. Land selling.');
    end,
    pic = 'images/city_corn.png',
    entered = function (s)
        vvod._txt = '';
        vvod:act();
    end,
    forcedsc = true;
    dsc = function (s)
        p ('^How much acres you want to sell for ', CurrLandPrice, ' bushels/acre ?');
        p ('^^Now you have:');
        p ('^Grain: ', Corn.now, ' bushels.');
        p ('^People: ', People.now, ' man.');
        p ('^People need: ', People.now*40, ' bushels of grain for food.');
        p ('^Land in possess: ', Land.now, ' acres.');
        p ('^Land required: ', People.now*5, ' acres.');
        p ('^^How much acres?');
    end,
    inp_enter = function()
        local a = 0;
        a = tonumber(vvod:text());
        if not a then
            p 'Error - this is not a number.';
            vvod:act();
            return;
        end
        if (a < 0) then
            a = 0;
        end
        if (a > Land.now) then
            p 'You have not that much land!';
            vvod:act();
            return;
        end
        if (not (a == 0)) then
            if (a > Land.now-25) then
                p 'And where are your peoples will live?';
                vvod:act();
                return;
            end
        end
        if ( a > (1000 + Science.buy*500) ) then
            m = a;
            return walk (ShowSellLandDialog_too_much);
        end
        Land.corn = Land.corn - a;
        Land.now = Land.now - a;
        Corn.land = Corn.land + CurrLandPrice * a;
        Corn.now = Corn.now + CurrLandPrice * a;
        Statistics.land_sold = Statistics.land_sold + a;
        if ( (People.now*5)> Land.now ) then 
            Yoke = Yoke + math.floor ((20 - Science.policy)*(People.now*4/(Land.now))/3);
            p '^People are unhappy! Too high density of population for this amount of land!';
        end
        return walk (ShowEatDialog);
    end;
    obj = { 'vvod' },
};


ShowSellLandDialog_too_much = room {
    nam = function (s)
        p ('Year '..Year..'. Land selling.');
    end,
    pic = 'images/labour.png',
    dsc = function (s)
        p ('You want to sell too much land. The price in this case will be ', CurrLandPrice-1, ' bushels/acre.');
    end,
    obj = { vway('1', '{Yes, sell it}^', 'ShowEatDialog'),
            vway('2', '{No, I need to enter less number}', 'ShowSellLandDialog') },
    exit = function (s, to)
        if to == ShowEatDialog then
            CurrLandPrice = CurrLandPrice - 1;
            Land.now = Land.now - m;
            Land.corn = Land.corn -m;
            Corn.land = CurrLandPrice * m;
            Corn.now = Corn.now + Corn.land;
            Statistics.land_sold = Statistics.land_sold + m;
            if ( (People.now*5)> Land.now ) then 
                Yoke = Yoke + math.floor ((20 - Science.policy)*(People.now*4/(Land.now))/3);
                p '^People are unhappy! Too high density of population for this amount of land!';
            end
        end
    end,
};
