ShowEatDialog = room {
    nam = function (s)
        p ('Year '..Year..'. Feeding people.');
    end,
    pic = 'images/lazy_people.png',
    entered = function (s)
        vvod._txt = '';
        vvod:act();
    end,
    forcedsc = true;
    dsc = function (s)
        p ('How much bushels of grain do you allow to use your people for food?');
        p ('^^Now you have:');
        p ('^Grain: ', Corn.now, ' bushels.');
        p ('^People: ', People.now, ' man.');
        p ('^People need: ', People.now*40, ' bushels of grain.');
        p ('^How much bushels?');
    end,
    inp_enter = function()
        local a = 0;
        a = tonumber(vvod:text());
        if not a then
            p 'Error - this is not a number.';
            vvod:act();
            return;
        end
        if (a < 0) then
            a = 0;
        end
        if (a > Corn.now) then
            p 'You have no that much of grain!';
            vvod:act();
            return;
        end
        if ( (a < 50) and (Corn.now >= 50)) then
            p 'Do not be greedy. Your people need food..';
            vvod:act();
            return;
        end
        Corn.food = a;
        Corn.now = Corn.now - Corn.food;
        People.hunger = (People.now - math.floor (Corn.food/40));
        if (People.hunger < 0) then
            People.hunger = 0;
            Yoke = Yoke - 2 - math.floor (Science.policy/5);
        else
            People.now = People.now - People.hunger;
            tmp = math.floor (People.hunger/2.5 - Science.policy/4);
            if (tmp > 20) then
                tmp = 20;
            end
            Yoke = Yoke + tmp;
        end
        return walk (ShowSowDialog);
    end,
    obj = { 'vvod' },
};
