ShowShipBuildDialog = room {
    nam = function (s)
        p ('Год '..Year..'. Строительство кораблей.');
    end,
    pic = 'images/port.png',
    enter = function (s)
        if (not isPort) then
            return walk (ShowNews);
        end
        tmp = math.random (10000);
        ShipPrice = tmp + 20000 - Science.buy*150 - Science.ships*75;
        m = math.floor (Corn.now/ShipPrice);
        vvod._txt = '';
        vvod:act();
    end,
    forcedsc = true;
    dsc = function (s)
        p ('Сколько кораблей Вы построите?');
        p ('^^На данный момент у Вас:');
        p ('^Зерна: ', Corn.now, ' бушелей.');
        p ('^Людей: ', People.now, ' человек.');
        p ('^Цена за один корабль: ', ShipPrice, ' бушелей зерна.');
        p ('^Сейчас кораблей: ', Ships.now, ' штук.');
        p ('^Максимально можно построить: ', m, ' кораблей за ', m*ShipPrice, ' бушелей зерна.');
        p ('^Сколько кораблей построить?');
    end,
    inp_enter = function()
        local a = 0;
        a = tonumber(vvod:text());
        if not a then
            p 'Ошибка - это не число.';
            vvod:act();
            return;
        end
        if (a < 0) then
            a = 0;
        end
        if (a > m) then
            p 'У Вас нет столько зерна!';
            vvod:act();
            return;
        end
        Ships.build = a;
        Ships.now = Ships.now + Ships.build;
        Corn.ships = a*ShipPrice;
        Corn.now = Corn.now - Corn.ships;
        return walk (ShowPortDialog);
    end,
    obj = { 'vvod' },
};


ShowPortDialog = room {
    nam = function (s)
        p ('Год '..Year..'. Отправление кораблей.');
    end,
    pic = 'images/port.png',
    enter = function (s)
        if (Ships.now == 0) then
            return walk (ShowPortDialog_no_ships);
        end
        tmp = math.random();
        if (tmp > 0.85) then
            return walk (ShowPortDialog_storm);
        end
        qq = math.floor (People.now / (1.3 - Science.war/50));
        v = 15 + Science.ships * 2;
        if (qq > (Ships.now*v)) then
            m = Ships.now * v;
        else
            m = qq;
        end
        vvod._txt = '';
        vvod:act();
    end,
    forcedsc = true;
    dsc = function (s)
        p ('^Сколько человек Вы отправите в плавание?');
        p ('^^На данный момент у Вас:');
        p ('^Кораблей: ', Ships.now, ' штук.');
        p ('^Людей: ', People.now, ' человек.');
        p ('^Боеспособного населения: ', qq, ' человек.');
        p ('^Максимально можно отправить: ', m, ' воинов.');
        p ('^Сколько человек отправить?');
    end,

    inp_enter = function()
        local a = 0;
        a = tonumber(vvod:text());
        if not a then
            p 'Ошибка - это не число.';
            vvod:act();
            return;
        end
        if (a < 0) then
            a = 0;
        end
        if (a > People.now) then
            p 'У Вас нет столько людей!';
            vvod:act();
            return;
        end
        if (a > qq) then
            p 'У Вас нет столько боеспособных людей!';
            vvod:act();
            return;
        end
        if (a > m) then
            p 'Не хватает кораблей для всех воинов!';
            vvod:act();
            return;
        end
        People.port = -a;
        People.now = People.now + People.port;
        People.sail = People.sail - People.port;
--        Ships.port = -Ceil (a/v);
        Ships.port = (-1) * math.floor (a/v);
        Ships.now = Ships.now + Ships.port;
        Ships.sail = Ships.sail - Ships.port;
        return walk (ShowNews);
    end,
    obj = { 'vvod' },
};


ShowPortDialog_no_ships = room {
    nam = 'Набор моряков',
    pic = 'images/port.png',
    dsc = function (s)
        return 'Набор моряков остановлен из-за отсутствия судов.';
    end,
    obj = { vway('1', '{Далее}^', 'ShowNews') },
};


ShowPortDialog_storm = room {
    nam = 'Набор моряков',
    pic = 'images/port.png',
    dsc = function (s)
        return 'Гавань закрыта по причине сильного шторма.';
    end,
    obj = { vway('1', '{Далее}^', 'ShowNews') },
};

