ShowScienceDialog = room {
    nam = function (s)
        p ('Year '..Year..'. Scientific research.');
    end,
    pic = 'images/academy.png',
    enter = function (s)
        if (not isScience) then
            return walk (ShowShipBuildDialog);
        end
        if ((Science.people==10)and(Science.land==10)and(Science.corn==10)and(Science.ships==10)and(Science.war==10)and(Science.buy==10)and(Science.policy==10)and(Science.medicine==10)) then
            if (not (Science.integrity == 0)) then
                Science.integrity = 0;
                return walk (ShowScienceDialog_over);
            end
        end
        vvod._txt = '';
        vvod:act();
    end,
    forcedsc = true;
    dsc = function (s)
        p ('How much bushels of grain do you want to spend on scientific research?');
        p ('^^Now you have:');
        p ('^Grain: ', Corn.now, ' bushels.');
        p ('^People: ', People.now, ' man.');
        p ('^How much bushels?');
    end,
    inp_enter = function()
        local a = 0;
        a = tonumber(vvod:text());
        if not a then
            p 'Error - this is not a number.';
            vvod:act();
            return;
        end
        if (a < 0) then
            a = 0;
        end
        if (a > Corn.now) then
            p 'You have no that much grain!';
            vvod:act();
            return;
        end
        Corn.science = a;
        Corn.now = Corn.now - Corn.science;
        Statistics.science_spend = Statistics.science_spend + Corn.science;
        tmp = math.random (10);
        Science.integrity = Science.integrity + math.floor(Corn.science/(20+Science.count/2)) + tmp - 5;
        if (Science.integrity<0) then
            Science.integrity = 1;
        end
        return walk (ShowShipBuildDialog);
    end,
    obj = { 'vvod' },
};


ShowScienceDialog_over = room {
    _showed = false,
    nam = function (s)
        p ('Year '..Year..'. Scientific research.');
    end,
    pic = function (s)
        return 'images/academy.png';
    end,
    enter = function (s)
        if s._showed then
            return walk (ShowShipBuildDialog);
        end
    end,
    dsc = function (s)
        return 'Academy is closed - all research have done!';
    end,
    obj = { vway('1', '{Next}', 'ShowShipBuildDialog') },
    exit = function (s)
        s._showed = true;
    end,
};
