CheckForWar = room {
    nam = '«KoG» CheckForWar',
--    pic = 'images/war.png',
    enter = function (s)
        result = 0;
        Rebel = false;
        SeaWar = false;
        Allend = false;
        Monster = false;

        if (Year == MegaMonster) then
            return walk (CheckForWar_Army_of_Darkness);
        end

        if ( (Year<8) or (Year>85)) then
            return walk (ShowPeaceTalkDialog);
        end

        if igo then
            return walk (CheckForWar_igo);
        end

        tmp = math.random();
        if ( tmp>(0.75+Science.policy/100) ) then
            return walk (CheckForWar_war_approach);
        end

        tmp = math.random();
        if ( tmp>(0.75-Science.war/100) ) then
            m  = math.random();
            v  = math.random(20);
            qq = math.random( math.floor(Year/3) );
            pp = math.random( Year*10 );
            if ( (Year*(m*10+(10-sudden/15))) < (Corn.now/(v+70+qq)+People.now+pp) ) then
                return walk (CheckForWar_sudden_attack);
            end
        end

        tmp = math.random();
        if ( (tmp>(0.75 - Science.ships/100)) and (Ships.sail>0) ) then
            return walk (CheckForWar_seawar);
        end

        tmp = math.random();
        if ( (Yoke>=60) and (tmp>0.5) ) then
            return walk (CheckForWar_rebellion);
        end

-- qqq need add following in any case?
        return walk (ShowPeaceTalkDialog);
    end,
    obj = { vway('1', '{Далее}', 'ShowPeaceTalkDialog') },
};


CheckForWar_Army_of_Darkness = room {
    nam = function (s)
        p ('Год '..Year..'. Армия Тьмы у ворот!');
    end,
    pic = 'images/city_army_approach.png',
    enter = function (s)
        Monster = true;
        result = 666;
    end,
    dsc = function(s)
        if isTower then
            return 'Теперь отступать некуда. Сам Сатана с армией Тьмы у ворот крепости!^Похоже, Башня сделала своё дело! Половина Армии Тьмы сгорела при подходе к королевству.';
        else
            return 'Теперь отступать некуда. Сам Сатана с армией Тьмы у ворот крепости!';
        end
    end,
    obj = { vway('1', '{Далее}', 'ShowPeaceTalkDialog') },
};


CheckForWar_igo = room {
    nam = function (s)
        p ('Год '..Year..'. Пришла пора свергнуть захватчиков!');
    end,
    pic = 'images/rebellion.png',
    enter = function (s)
        result = 5;
    end,
    dsc = function(s)
        return 'Настало время показать этим захватчикам где раки зимуют! Собирайте большую армию - их войско внушает страх!';
    end,
    obj = { vway('1', '{Далее}', 'ShowPeaceTalkDialog') },
};


CheckForWar_war_approach = room {
    nam = function (s)
        p ('Год '..Year..'. Угроза войны!');
    end,
    pic = 'images/rebellion.png',
    enter = function (s)
        result = 1;
        sudden = 0;
    end,
    dsc = function (s)
        return 'Соседнее королевство угрожает войной!';
    end,
    obj = { vway('1', '{Далее}', 'ShowPeaceTalkDialog') },
};


CheckForWar_sudden_attack = room {
    nam = function (s)
        p ('Год '..Year..'. Внезапная атака.');
    end,
    pic = 'images/city_army.png',
    dsc = function(s)
        p ('Рядом c Вашим королевством обосновалось ещё одно - слабое и беззащитное. Главнокомандующие предлагают внезапную атаку.');
        p ('^Последнее слово за Вами...');
    end,
    obj = { vway('1', '{Атаковать}^', 'main_cycle'),
            vway('2', '{Подождать}', 'ShowPeaceTalkDialog') },
    exit = function (s, to)
        if to == main_cycle then
            result = 2;
            sudden = 10 + Science.war;
        end
        return walk (ShowPeaceTalkDialog);
    end,
};


CheckForWar_seawar = room {
    nam = function (s)
        p ('Год '..Year..'. Морская битва.');
    end,
    pic = 'images/city_army.png',
    dsc = function(s)
        p ('Ваш флот в состоянии напасть на торговые корабли противника!');
        p ('^Последнее слово за Вами...');
    end,
    obj = { vway('1', '{На абордаж!}^', 'main_cycle'),
            vway('2', '{Отставить}', 'ShowPeaceTalkDialog') },
    exit = function (s, to)
        if to == main_cycle then
            result = 3;
            sudden = 20 + Science.war;
            SeaWar = true;
        end
        return walk (ShowPeaceTalkDialog);
    end,
};


CheckForWar_rebellion = room {
    nam = 'Восстание!',
    pic = 'images/rebellion.png',
    enter = function (s)
        result = 4;
        Rebel = true;
    end,
    dsc = function(s)
        return 'Народ больше не в силах терпеть постоянные лишения!^Взбунтовавшиеся крестьяне отделились от королевства и начинают нападать на замок!';
    end,
    obj = { vway('1', '{Далее}', 'ShowPeaceTalkDialog') },
};
