CheckForWar = room {
    nam = '«KoG» CheckForWar',
--    pic = 'images/war.png',
    enter = function (s)
        result = 0;
        Rebel = false;
        SeaWar = false;
        Allend = false;
        Monster = false;

        if (Year == MegaMonster) then
            return walk (CheckForWar_Army_of_Darkness);
        end

        if ( (Year<8) or (Year>85)) then
            return walk (ShowPeaceTalkDialog);
        end

        if igo then
            return walk (CheckForWar_igo);
        end

        tmp = math.random();
        if ( tmp>(0.75+Science.policy/100) ) then
            return walk (CheckForWar_war_approach);
        end

        tmp = math.random();
        if ( tmp>(0.75-Science.war/100) ) then
            m  = math.random();
            v  = math.random(20);
            qq = math.random( math.floor(Year/3) );
            pp = math.random( Year*10 );
            if ( (Year*(m*10+(10-sudden/15))) < (Corn.now/(v+70+qq)+People.now+pp) ) then
                return walk (CheckForWar_sudden_attack);
            end
        end

        tmp = math.random();
        if ( (tmp>(0.75 - Science.ships/100)) and (Ships.sail>0) ) then
            return walk (CheckForWar_seawar);
        end

        tmp = math.random();
        if ( (Yoke>=60) and (tmp>0.5) ) then
            return walk (CheckForWar_rebellion);
        end

-- qqq need add following in any case?
        return walk (ShowPeaceTalkDialog);
    end,
    obj = { vway('1', '{Next}', 'ShowPeaceTalkDialog') },
};


CheckForWar_Army_of_Darkness = room {
    nam = function (s)
        p ('Year '..Year..'. Army of Darkness at the gate!');
    end,
    pic = 'images/city_army_approach.png',
    enter = function (s)
        Monster = true;
        result = 666;
    end,
    dsc = function(s)
        if isTower then
            return 'You have nowhere to retreat. Satan itself with an Army of Darkness at the gate of your stronghold!^It seems that Tower of Light have done it’s part! The half of an Darkness Army burned while approaching to your Kingdom.';
        else
            return 'You have no place to retreat. Satan itself with an Army of Darkness at the gate of your stronghold!';
        end
    end,
    obj = { vway('1', '{Next}', 'ShowPeaceTalkDialog') },
};


CheckForWar_igo = room {
    nam = function (s)
        p ('Year '..Year..'. It’s time to dethrone aggressors!');
    end,
    pic = 'images/rebellion.png',
    enter = function (s)
        result = 5;
    end,
    dsc = function(s)
        return 'It is time now to show these invaders our strength! Gather a big army - their forces is arrousing fear!';
    end,
    obj = { vway('1', '{Next}', 'ShowPeaceTalkDialog') },
};


CheckForWar_war_approach = room {
    nam = function (s)
        p ('Year '..Year..'. Menace of war!');
    end,
    pic = 'images/rebellion.png',
    enter = function (s)
        result = 1;
        sudden = 0;
    end,
    dsc = function (s)
        return 'The neighbout kingdom menace of war!';
    end,
    obj = { vway('1', '{Next}', 'ShowPeaceTalkDialog') },
};


CheckForWar_sudden_attack = room {
    nam = function (s)
        p ('Year '..Year..'. Suden strike.');
    end,
    pic = 'images/city_army.png',
    dsc = function(s)
        p ('Not far from you new kingdom is settle down. It’s weak and unprotected now. Your Supreme Commander-in-Chief offers you sudden strike on it.');
        p ('^What is your final word?');
    end,
    obj = { vway('1', '{Attack}^', 'main_cycle'),
            vway('2', '{Wait}', 'ShowPeaceTalkDialog') },
    exit = function (s, to)
        if to == main_cycle then
            result = 2;
            sudden = 10 + Science.war;
        end
        return walk (ShowPeaceTalkDialog);
    end,
};


CheckForWar_seawar = room {
    nam = function (s)
        p ('Year '..Year..'. Sea battle.');
    end,
    pic = 'images/city_army.png',
    dsc = function(s)
        p ('Your fleet is able to attack on enemy merchant ships!');
        p ('^What is your final word?');
    end,
    obj = { vway('1', '{All a board!}^', 'main_cycle'),
            vway('2', '{As you were}', 'ShowPeaceTalkDialog') },
    exit = function (s, to)
        if to == main_cycle then
            result = 3;
            sudden = 20 + Science.war;
            SeaWar = true;
        end
        return walk (ShowPeaceTalkDialog);
    end,
};


CheckForWar_rebellion = room {
    nam = 'Rebellion!',
    pic = 'images/rebellion.png',
    enter = function (s)
        result = 4;
        Rebel = true;
    end,
    dsc = function(s)
        return 'People can not suffer constant asperity no more!^Rebel peasant separate from your Kingdom and start to attack on a castle!';
    end,
    obj = { vway('1', '{Next}', 'ShowPeaceTalkDialog') },
};
