ShowShipBuildDialog = room {
    nam = function (s)
        p ('Year '..Year..'. Shipyard.');
    end,
    pic = 'images/port.png',
    enter = function (s)
        if (not isPort) then
            return walk (ShowNews);
        end
        tmp = math.random (10000);
        ShipPrice = tmp + 20000 - Science.buy*150 - Science.ships*75;
        m = math.floor (Corn.now/ShipPrice);
        vvod._txt = '';
        vvod:act();
    end,
    forcedsc = true;
    dsc = function (s)
        p ('How much ships do you want to build?');
        p ('^^Now you have:');
        p ('^Grain: ', Corn.now, ' bushels.');
        p ('^People: ', People.now, ' man.');
        p ('^Price of one ship is: ', ShipPrice, ' bushels of grain.');
        p ('^You already have: ', Ships.now, ' ships.');
        p ('^Maximum you can build: ', m, ' ships for ', m*ShipPrice, ' bushels of grain.');
        p ('^How much ship do you want to build?');
    end,
    inp_enter = function()
        local a = 0;
        a = tonumber(vvod:text());
        if not a then
            p 'Error - this is not a number.';
            vvod:act();
            return;
        end
        if (a < 0) then
            a = 0;
        end
        if (a > m) then
            p 'You have not that much of grain!';
            vvod:act();
            return;
        end
        Ships.build = a;
        Ships.now = Ships.now + Ships.build;
        Corn.ships = a*ShipPrice;
        Corn.now = Corn.now - Corn.ships;
        return walk (ShowPortDialog);
    end,
    obj = { 'vvod' },
};


ShowPortDialog = room {
    nam = function (s)
        p ('Year '..Year..'. The departure of a ships.');
    end,
    pic = 'images/port.png',
    enter = function (s)
        if (Ships.now == 0) then
            return walk (ShowPortDialog_no_ships);
        end
        tmp = math.random();
        if (tmp > 0.85) then
            return walk (ShowPortDialog_storm);
        end
        qq = math.floor (People.now / (1.3 - Science.war/50));
        v = 15 + Science.ships * 2;
        if (qq > (Ships.now*v)) then
            m = Ships.now * v;
        else
            m = qq;
        end
        vvod._txt = '';
        vvod:act();
    end,
    forcedsc = true;
    dsc = function (s)
        p ('^How much man do you want to go sailing?');
        p ('^^Now you have:');
        p ('^Ships: ', Ships.now, ' items.');
        p ('^People: ', People.now, ' man.');
        p ('^Battle-worthy settling: ', qq, ' man.');
        p ('^Maximum you can departure: ', m, ' warriors.');
        p ('^How much man do you want to go sailing?');
    end,

    inp_enter = function()
        local a = 0;
        a = tonumber(vvod:text());
        if not a then
            p 'Error - this is not a number.';
            vvod:act();
            return;
        end
        if (a < 0) then
            a = 0;
        end
        if (a > People.now) then
            p 'You have no that much man';
            vvod:act();
            return;
        end
        if (a > qq) then
            p 'You have no that much warrirors!';
            vvod:act();
            return;
        end
        if (a > m) then
            p 'You have no ships to place all of your warriors!';
            vvod:act();
            return;
        end
        People.port = -a;
        People.now = People.now + People.port;
        People.sail = People.sail - People.port;
--        Ships.port = -Ceil (a/v);
        Ships.port = (-1) * math.floor (a/v);
        Ships.now = Ships.now + Ships.port;
        Ships.sail = Ships.sail - Ships.port;
        return walk (ShowNews);
    end,
    obj = { 'vvod' },
};


ShowPortDialog_no_ships = room {
    nam = 'Seaman recruit',
    pic = 'images/port.png',
    dsc = function (s)
        return 'Seaman recruit is restrained becouse of absence of ships.';
    end,
    obj = { vway('1', '{Next}^', 'ShowNews') },
};


ShowPortDialog_storm = room {
    nam = 'Seaman recruit',
    pic = 'images/port.png',
    dsc = function (s)
        return 'Harbour is closed becouse of strong storm.';
    end,
    obj = { vway('1', '{Next}^', 'ShowNews') },
};

