ShowNews = room {
    nam = function (s)
        p ('Год '..Year..'. Последние новости.');
    end,
    enter = function (s)
        if (Year <= 2) then
            return walk (CheckForWar);
        end
        if (Year > 2) then
            events = 0;
            -- Bad News

            -- Thief corn
            tmp = math.random ();
            if ( (tmp > (0.95 + Science.policy/50)) and (Corn.now > 100) ) then
                p (imgl 'images/rebellion.png');
                p ('Несколько человек украло часть зерна и покинуло ваше Королевство!^');
                tmp = math.random (100);
                Corn.thiefs = Corn.thiefs + math.floor (Corn.now / (tmp + 100));
                tmp = math.random ( 15 - math.floor(Science.policy/2) );
                People.thiefs = People.thiefs - tmp;
                if ( (People.now + People.thiefs) < 2 ) then
                    People.thiefs = People.now - 2;
                end
                Yoke = Yoke - 2;
                events = events + 1;
            end
            Statistics.thief_grain = Statistics.thief_grain + Corn.thiefs;

            -- Thief land
            tmp = math.random ();
            if ( (tmp > (0.95 + Science.policy/50)) and (Land.now > 100) ) then
                p (imgl 'images/rebellion.png');
                p ('Несколько человек перешли в Соседнее королевство, прихватив с собой часть Ваших земель!^');
                tmp = math.random (10);
                Land.thiefs = Land.thiefs + math.floor (Land.now / (tmp + 10));
                tmp = math.random ( 15 - math.floor(Science.policy/2) );
                People.thiefs = People.thiefs - tmp;
                if ( (People.now + People.thiefs) < 2 ) then
                    People.thiefs = People.now - 2;
                end
                Yoke = Yoke - 2;
                events = events + 1;
                Statistics.thief_land = Statistics.thief_land + Land.thiefs;
            end

            -- Rats
            tmp = math.random ();
            if (tmp > (0.45 + Science.corn / 40)) then
              if (Epidemy.radiation > 0) then
                    p (imgl 'images/rats_are_dead.png');
                    p ('Крысы в Ваших амбарах сдохли от радиации.^');
                    events = events + 1;
                else
                    if (Corn.now > 0) then
                        p (imgl 'images/rats.png');
                        p ('Крысы наводнили Ваши амбары!^');
                        Corn.rats = math.floor (Corn.now / (20 + Science.corn * 1.5));
                        events = events + 1;
                    end
                end
                Statistics.rats = Statistics.rats + Corn.rats;
            end

            -- Hard rain
            tmp = math.random ();
            if ((tmp > 0.79) and (Corn.seed > 0)) then
                p (imgl 'images/rain.png');
                p ('Крупный град уничтожил весь урожай!^');
                Statistics.hard_rain = Statistics.hard_rain + Corn.harvest;
                Corn.harvest = 0;
                events = events + 1;
            end

            -- Cholera
            tmp = math.random ();
            if ( tmp > (0.75 + Science.medicine/50) ) then
                p (imgl 'images/graveyard.png');
                p ('Эпидемия холеры поразила королевство!^');
                People.illness = People.illness + math.floor (People.now / (10 + Science.medicine));
                Yoke = Yoke + math.floor (People.illness/50);
                events = events + 1;
                Statistics.disease = Statistics.disease + People.illness;
            end;

            -- Disease
            tmp = math.random ();
            if ( tmp > (0.95 + Science.medicine/50)) then
                p (imgl 'images/graveyard.png');
                p ('Эпидемия Ящура скосила половину населения!^');
                People.illness = People.illness + math.floor(People.now / (2 + Science.medicine/10));
                Yoke = Yoke + math.floor(People.illness/50);
                events = events + 1;
                Statistics.disease = Statistics.disease + People.illness;
            end

            -- Locust
            tmp = math.random ();
            if ( (Epidemy.bugs == 0) and (tmp > (0.8975 + Science.medicine/100))) then
                if (Epidemy.radiation > 0) then
                    p (imgl 'images/locust.png');
                    p ('Из-за радиации саранча не смогла подлететь к Вашим полям.^');
                else
                    p (imgl 'images/locust.png');
                    p ('Трёхлетнее нашествие саранчи!^');
                    Epidemy.bugs = 3;
                    Statistics.locust = Statistics.locust + 1;
                end
                events = events + 1;
            end

            -- Plague
            tmp = math.random ();
            if ( (tmp > (0.979 + Science.medicine/500)) and (Epidemy.plague == 0) ) then
                tmp = math.random (3);
                a = tmp + 5;
                p (imgl 'images/graveyard.png');
                p ('Ваше королевство охватила Чума!^Возможные последствия: высокая смертность, низкая рождаемость.');
                p ('^По прогнозам ученых болезнь отступит только через ', a, ' лет!^');
                Epidemy.plague = a;
                events = events + 1;
                Statistics.plague = Statistics.plague + 1;
            end

            -- meteorites
            tmp = math.random ();
            if ( (tmp > 0.975) and (isScience) and (Epidemy.radiation == 0) ) then
                tmp = math.random (5);
                a = tmp + 10;
                p (imgl 'images/graveyard.png');
                p ('Упавший неподалёку метеорит намного повысил радиационный фон в королевстве.^Возможные последствия: низкая рождаемость и урожай.');
                p ('^Учёные утверждают, что период полураспада атомов в астероиде ', a, ' лет.^');
                Epidemy.radiation = a;
                events = events + 1;
                Statistics.meteorites = Statistics.meteorites + 1;
            end

            -- land dec
            tmp = math.random ();
            if ( (tmp > (0.875 + Science.land/75)) and (isScience) ) then
                p (imgl 'images/dry_land.png');
                p ('В результате неудачных опытов учёных была испорчена часть земли.^');
                tmp = math.random (10);
                Land.spoiled = Land.spoiled + math.floor (Land.now / (tmp + 10));
                events = events + 1;
                Statistics.land_spoiled = Statistics.land_spoiled + Land.spoiled;
            end

            -- corn dec
            tmp = math.random ();
            if ( (tmp > (0.875 + Science.corn/75)) and (isScience) ) then
                p (imgl 'images/sand.png');
                p('Кучка учёных-дилетантов сожгла часть драгоценного зерна.^');
                tmp = math.random (100);
                Corn.spoiled = Corn.spoiled + math.floor (Corn.now / (tmp + 100));
                events = events + 1;
                Statistics.grain_spoiled = Statistics.grain_spoiled + Corn.spoiled;
            end

            -- people leave
            tmp = math.random ();
            if ( tmp > (0.85 - Yoke/250) ) then
                p (imgl 'images/rebellion.png');
                p ('Несколько человек покинули Ваше королевство, недовольные уровнем жизни.^');
                tmp = math.random ( 15 - math.floor(Science.policy/2) );
                People.balance = People.balance - tmp;
                if ( (People.now + People.balance) < 2 ) then
                    People.balance = People.now - 2;
                end
                events = events + 1;
                Statistics.people_left = Statistics.people_left + People.balance;
            end

            -- deal is off
            tmp = math.random ();
            if ( (Deal > 0) and (tmp > 0.99) ) then
                p (imgl 'images/dry_land.png');
                p ('Королевство, с которым Вы заключили сделку, подверглось нападению.^Ваши вложения бесследно исчезли.^');
                Statistics.deal_off = Statistics.deal_off + Corn.deal;
                Corn.deal = 0;
                Deal = 0;
                events = events + 1;
            end

            -- war
            tmp = math.random ();
            if ( (Year>15) and (tmp>0.98) and (Epidemy.igo==0) and (Epidemy.radiation==0) and (Year<85) ) then
                p (imgl 'images/city_army_approach.png');
                tmp = math.random (5);
                a = tmp + 5;
                p ('К стенам Вашего замка надвигается громадное войско. Главнокомандующий этого войска отправляет Вам запрос: «Предлагаю мирный выход из ситуации:');
                p ('^В течение ', a, ' лет Вы исправно платите нам небольшую дань, а мы в свою очередь Вас не тронем».^');
                Epidemy.igo = a;
                events = events + 1;
            end

            -- //Good News
            -- people add
            tmp = math.random ();
            if (tmp > 0.75) then
                p (imgl 'images/lazy_people.png');
                p ('Соседние кочевые племена решили примкнуть к вашему королевству.^');
                tmp = math.random (10);
                a = tmp + 10 + math.floor (Science.policy/2);
                People.balance = People.balance + a;
                Yoke = Yoke - 2;
                events = events + 1;
                Statistics.nomads = Statistics.nomads + People.balance;
            end

            -- people add
            tmp = math.random ();
            if (tmp > 0.75) then
                p (imgl 'images/population_grow.png');
                p ('В Вашем королевстве произошёл демографический взрыв!^');
                tmp = math.random (10);
                a = tmp + 15 + math.floor (Science.policy/2);
                People.born = People.born + a;
                Yoke = Yoke - 2;
                events = events + 1;
            end

            -- artefacts
            tmp = math.random ();
            if ( (tmp > 0.9) and (isScience) ) then
                p (imgl 'images/city_corn.png');
                p ('В результате раскопок Ваши археологи наткнулись на ценные артефакты, которые они сразу обменяли на зерно в соседнем королевстве.^');
                tmp = math.random ();
                Corn.bonus = Corn.bonus + math.floor ( Year * 500 * (1 + tmp) );
                events = events + 1;
                Statistics.artefacts = Statistics.artefacts + Corn.bonus;
            end

            -- corn add
            tmp = math.random ();
            if (tmp > (0.7 - Science.corn / 100) ) and (isScience) then
                p (imgl 'images/city_corn.png');
                p ('Учёным Вашего королевства удалось получить немного искуственного зерна.^');
                tmp = math.random (2500);
                a = tmp + 2500;
                Corn.bonus = Corn.bonus + a;
                events = events + 1;
                Statistics.artificial_grain = Statistics.artificial_grain + Corn.bonus;
            end

            -- land add
            tmp = math.random ();
            if ( tmp > (0.7 - Science.land / 100) ) and (isScience) then
                p (imgl 'images/dry_land.png');
                p ('Учёным удалось сделать плодородными безжизненные земли на границах Вашего королевства. Теперь они принадлежат Вам.^');
                tmp = math.random (250);
                Land.bonus = tmp + 250;
                events = events + 1;
                Statistics.land_fertalization = Statistics.land_fertalization + Land.bonus;
            end

            -- locust remove
            tmp = math.random ();
            if ( (tmp > 0.9) and (Epidemy.bugs > 0) and (Epidemy.bugs < 7) ) then
                p (imgl 'images/corn.png');
                p ('Вашим людям удалось найти средство от надоедливой саранчи.^');
                Epidemy.bugs = 0;
                Yoke = Yoke - 2;
                events = events + 1;
                Statistics.locust_remove = Statistics.locust_remove + 1;
            end

            -- radiation off
            tmp = math.random ();
            if ((tmp>0.9)and(Epidemy.radiation>0)and(Epidemy.radiation<12)and(isScience)) then
                p (imgl 'images/city_corn.png');
                p ('Учёным удалось изолировать источник радиационных волн.^');
                Epidemy.radiation = 0;
                Yoke = Yoke - 2;
                events = events + 1;
                Statistics.radiation_off = Statistics.radiation_off + 1;
            end

            -- plague off
            tmp = math.random ();
            if ((tmp>0.9)and(Epidemy.plague>0)and(Epidemy.plague<6)and(isScience)) then
                p (imgl 'images/city_corn.png');
                p ('Поразительно, но Вашими медиками было разработано лекарство от чумы.^');
                Epidemy.plague = 0;
                Yoke = Yoke - 2;
                events = events + 1;
                Statistics.plague_off = Statistics.plague_off + 1;
            end

            -- //Epidemies and Deals
            if (Epidemy.radiation > 0) then
                Land.spoiled = Land.spoiled + math.floor (Land.now / (50 + Science.land * 5));
                Epidemy.radiation = Epidemy.radiation - 1;
                Yoke = Yoke + 1;
                if (Epidemy.radiation == 0) then
                    p (imgl 'images/lazy_people.png');
                    p ('Можете вздохнуть свободно - радиация ослабла!^');
                    events = events + 1;
                end
            end

            if (Epidemy.plague > 0) then
                People.illness = People.illness + math.floor ( People.now / (2 + Science.medicine/10) );
                Epidemy.plague = Epidemy.plague - 1;
                Yoke = Yoke + math.floor (People.illness / 50);
                if (Epidemy.plague == 0) then
                    p (imgl 'images/lazy_people.png');
                    p ('Можете выходить на улицы - чума искоренена!^');
                    events = events + 1;
                end
            end

            if (Epidemy.bugs > 0) then
                Epidemy.bugs = Epidemy.bugs - 1;
                if (Epidemy.bugs == 0) then
                    p (imgl 'images/city_corn.png');
                    p ('Саранча наконец-то отступила!^');
                    events = events + 1;
                end
            end

            if (Deal > 0) then
                Deal = Deal - 1;
                if (Deal == 0) then
                    p (imgl 'images/city_corn.png');
                    p ('Поздравляем Вас! Сделка с соседним королевством успешно завершена!^');
                    Corn.deal = -DealMoney * 3;
                    Corn.now = Corn.now + Corn.deal;
                    events = events + 1;
                end
                Statistics.deal_number = Statistics.deal_number + 1;
            end

            --  //Secret Messages
            if (Year == 7) then
                p (imgl 'images/main.png');
                p ('Запыхавшийся гонец приносит неприятную весть:^«Секретное донесение:^Видя Ваше процветание, другие короли решили поживиться этими богатствами и землей. Будьте бдительны и приготовьтесь, что в любой момент на королевство могут напасть.^^                                               Ваш тайный доносчик.»^');
                events = events + 1;
            end

            if (Year == 40) then
                p (imgl 'images/main.png');
                p ('Быстрым шагом к Вам подходит гонец и приносит Вам потёртый пергамент:^^«Секретное донесение:^^Весьма рад сообщить Вашему Величеству, что наша разведка выследила группу друидов в одном лесу. По заверению наших учёных, варево в их котлах может оказаться ни чем иным как эликсиром долголетия. Наши войска планируют захватить друидов, как только зелье будет готово. Ждите скорых вестей!^^                                               Ваш тайный доносчик.»^');
                events = events + 1;
            end

            if (Year == 49) then
                p (imgl 'images/main.png');
                p ('В ваш тронный зал влетает гонец. В руках у него послание:^^«Секретное донесение:^^Эликсир долголетия готов! Как только я получил эту радостную весть я тут же собрал всех своих людей и двинулся к злосчастному лесу. Но в лесу нас ждала засада! Элитные войска набросились на нас, как только мы подошли к котлу. Все мои люди мертвы. Я взят в плен. Скорее всего и мне не жить. Но главное: эликсир был утерян! Остаётся только надеятся, что учёные других королевств найдут этот эликсир.^                                                       Ваш тайный доносчик.»^');
                events = events + 1;
            end

            if (Year == 59) then
                p (imgl 'images/main.png');
                p ('Сейчас вы принимаете у себя одного странного торговца^^Торговец:^«...Разрешите сразу задать нескромный вопрос: Сколько вам лет? Можете не отвечать. Я знаю, что Вы очень не хотите покидать свой трон. Но Вы уже не молоды. И тут появляюсь я. Всего за каких 100000 бушелей зерна я предлагаю намного продлить Вашу жизнь с помощью уникального эликсира. Наши учёные недавно обнаружили его в одном старом лесу. Я не тороплю вас с ответом. Дайте мне знать, как только решитесь. Не буду больше тратить Ваше драгоценное время и с Вашего разрешения удалюсь.»^');
                events = events + 1;
            end

            if (Year == 80) then
                p (imgl 'images/main.png');
                p ('В тронный зал входит очень грязный мужчина.^Вы хотели было выгнать его, но ...:^«Пожалуйста, выслушайте меня! Я не какой-нибудь бомж. Я - король. Ну... бывший король. Моего королевства уже нет. Это было как в страшном сне: драконы, ...орки и прочая нежить. Казалось весь Легион Тьмы обрушился на нас!^Их войска насчитывают тысячи злобных и отвратительных созданий...^Естественно, мы не были готовы к такому повороту событий и жестоко поплатились. Я вынужден просить Вас о помощи: только Вы способны противостоять такой чудовищной армии. Если Вы ничего не предпримете, весь мир будет обречён. Ждать осталось недолго. Я сообщу Вам, как только достану больше информации.»^');
                tmp = math.random (5);
                MegaMonster = 95 + tmp;
                Epidemy.igo = 0;
                events = events + 1;
            end

            if (Year == MegaMonster) then
                p (imgl 'images/main.png');
                p ('В зал заходит израненый боец, волоча за собой кровавый след, но не дойдя до трона, падает замертво.^Вы тотчас же выскакиваете из дворца и понимаете, что всё хуже некуда. Небо окрасилось в бордовый цвет, повсюду паника. Страшный гул доносится всё ближе и ближе... Вдруг весь замок накрывает тень. Вы поднимаете глаза наверх, но уже прекрасно знаете, что увидите. Это дракон-разведчик.^Ну что-ж, пора готовится к последней битве. Неизвестно, выстоите Вы или нет, но надо отправить как можно больше этих тварей обратно в ад!^');
                events = events + 1;
            end

            if (events == 0) then
                return walk (ShowNewsDeal);
            end
        end
    end,
    obj = { vway('1', '^'..imgl('blank:1x1')..'{Далее}', 'ShowNewsDeal') },
};


ShowNewsDeal = room {
    nam = function (s)
        p ('Год '..Year..'. Вам предлагают сделку.');
    end,
    pic = 'images/lazy_people.png',
    enter = function (s)
        tmp = math.random ();
        if not ( (tmp>0.85) and (Deal == 0) and (Corn.now >= 5000) ) then
            return walk (ShowNewsIgo);
        end
        vvod._txt = '';
        vvod:act();
    end,
    forcedsc = true;
    dsc = function (s)
        p ('Торговцы из соседнего королевства предлагают беспроигрышную сделку и обещают прибыль в трёхкратном размере через 5 лет. Для этого лишь нужно вложить зерно в их проект.^Минимально можно вложить 5000 бушелей, максимум - 100000 бушелей.');
        p ('^Сколько бушелей зерна Вы вложите в дело?');
        p ('^^На данный момент у Вас:');
        p ('^Зерна: ', Corn.now, ' бушелей.');
        p ('^Людей: ', People.now, ' человек.');
        p ('^Людям для питания нужно: ', People.now*40, ' бушелей зерна.');
        p ('^Планируемый урожай: ', Corn.harvest, ' бушелей зерна.');
        p ('^Сколько бушелей?');
    end,
    inp_enter = function()
        local a = 0;
        a = tonumber(vvod:text());
        if not a then
            p 'Ошибка - это не число.';
            vvod:act();
            return;
        end
        if (a < 0) then
            a = 0;
        end
        if (a > Corn.now) then
            p 'У Вас нет столько зерна!';
            vvod:act();
            return;
        end
        if ( ((a < 5000) or (a > 100000)) and not (a==0) ) then
            p 'Торговцы не хотят иметь с Вами дело. Вы невнимательно прочитали условия сделки.';
            vvod:act();
            return;
        end
        if (a > 0) then
            Corn.deal = -a;
            Corn.now = Corn.now + Corn.deal;
            Deal = 5;
            DealMoney = -a;
        end
        return walk (ShowNewsIgo);
    end,
    obj = { 'vvod' },
};


ShowNewsIgo = room {
    nam = function (s)
        p ('Год '..Year..'.');
    end,
    pic = 'images/lazy_people.png',
    enter = function (s)
        if ( Epidemy.igo > 0 ) then
            Epidemy.igo = Epidemy.igo - 1;
            if (Epidemy.igo == 0) then
                return walk (ShowNewsIgo_Epidemy_is_over);
            end
            tmp = math.random ();
            if ( tmp > 0.975) then
                return walk (ShowNewsIgo_neighbour_is_killed);
            else
                return walk (ShowNewsIgo_paycheck);
            end
        end
        return walk (ShowNewInventions);
    end,
};


ShowNewsIgo_Epidemy_is_over = room {
    nam = function (s)
        p ('Год '..Year..'. Снятие осады!');
    end,
    pic = 'images/city_corn.png',
    dsc = function (s)
        return 'Враждебное королевство сняло осаду Вашей крепости!';
    end,
    obj = { vway('1', '{Далее}', 'ShowNewInventions') },
};


ShowNewsIgo_neighbour_is_killed = room {
    nam = function (s)
        p ('Год '..Year..'. Снятие осады!');
    end,
    pic = 'images/city_corn.png',
    enter = function (s)
        Epidemy.igo = 0;
    end,
    dsc = function (s)
        return ('Вам исключительно повезло: королевство, которому Вы платили дань, повержено - на него напали и стёрли с лица земли. Хоть это и не Ваша заслуга, жить теперь станет намного легче.');
    end,
    obj = { vway('1', '{Далее}', 'ShowNewInventions') },
};


ShowNewsIgo_paycheck = room {
    nam = function (s)
        p ('Год '..Year..'. Пришёл час расплаты.');
    end,
    pic = 'images/city_army_approach.png',
    enter = function (s)
      pp = math.floor (People.now/10); -- _p
      qq = math.floor (Corn.now/10); -- _c
      v  = math.floor (Land.now/10); -- _l
    end,
    dsc = function (s)
        p ('Пришло время платить дань. Противник выдвигает следующие требования. Необходимо отдать ему:');
        p ('^ - ', pp, ' человек;');
        p ('^ - ', v, ' акров земли;');
        p ('^ - ', qq,  ' бушелей зерна.');
        p ('^^Что Вы предпримите?');
--      writeln('    - Будем платить дань');writeln('    - Дадим отпор');
--      if Choose('YN')='Y' then
--      begin
--        People.war:=-_p;Corn.war:=-_c;land.war:=-_l;
--        People.now:=People.now-People.war;
--        Corn.now:=Corn.now-Corn.war;
--        Land.now:=Land.now-Land.war;
--      end
--        else begin Epidemy.igo:=0;igo:=True;end;
--    end;
-- after Igo => ShowNewInventions
    end,
    obj = { vway('1', '{Будем платить дань}^', 'main_cycle'),
            vway('2', '{Дадим отпор}', 'ShowNewInventions') },
    exit = function (s, to)
        if to == main_cycle then
            People.war = -pp;
            Corn.war   = -qq;
            Land.war   =  -v;
            People.now = People.now - People.war;
            Corn.now = Corn.now - Corn.war;
            Land.now = Land.now - Land.war;
            Statistics.igo_people = Statistics.igo_people + People.war;
            Statistics.igo_grain = Statistics.igo_grain + Corn.war;
            Statistics.igo_land = Statistics.igo_land + Land.war;
            return walk (ShowNewInventions);
        else
            Epidemy.igo = 0;
            igo = true;
        end
    end,
};
