ShowSowDialog = room {
    nam = function (s)
        p ('Year '..Year..'. Sowing.');
    end,
    pic = 'images/labour.png',
    enter = function (s)
        if (not isSow) then
            return walk (ShowScienceDialog);
        else
            if (Epidemy.bugs>0) then
                return walk (ShowSowDialog_Bugs);
            end
            if (Epidemy.radiation>0) then
                return walk (ShowSowDialog_Radiation);
            end
            vvod._txt = '';
            vvod:act();
            qq = (3 + Science.corn/2);
            p_tmp = math.floor (Land.now / (1.3 - Science.land/50));
            pp = p_tmp;
            if ( pp > math.floor (Corn.now/qq) ) then
                pp = math.floor (Corn.now/qq);
            end
            if ( pp > ((People.now)/1.2*4) ) then 
                pp = math.floor ((People.now)/1.2*4);
            end
            m = math.floor (pp*qq);
            -- //if m>corn.now then begin m:=corn.now;pp:=trunc(m/(3+Science.corn/2));m:=trunc(pp*(3+Science.corn/2));end;
        end
    end,
    forcedsc = true;
    dsc = function (s)
        p ('How much acres do you want to sow?');
        p ('^^Now you have:');
        p ('^Grain: ', Corn.now, ' bushels.');
        p ('^Fertile land: ', p_tmp, ' acres.' );
        p ('^People: ', People.now, ' man.');
        p ('^Total you can sow ', pp, ' acres of land. You will need ', m, ' bushels of grain for it.');
        p ('^How much acres do you want to sow?');
    end,
    inp_enter = function()
        local a = 0;
        a = tonumber(vvod:text());
        if not a then
            p 'Error - this is not a number.';
            vvod:act();
            return;
        end
        if (a < 0) then
            a = 0;
        end
        if (a > math.floor (Corn.now/qq)) then
            p 'You do not have enough grain for sowing!';
            vvod:act();
            return;
        end
        if (a > Land.now) then
            p 'You do not have enough land for sowing!';
            vvod:act();
            return;
        end
        if (a > (People.now/1.2*4)) then
            p 'You do not have enough labour force for sowing!';
            vvod:act();
            return;
        end
        Corn.seed = math.floor (a * qq);
        Corn.now = Corn.now - Corn.seed;
        Corn.harvest = Corn.seed * Corn.yield;
        Statistics.harvest = Statistics.harvest + Corn.harvest;
        return walk (ShowScienceDialog);
    end,
    obj = { 'vvod' },
};


ShowSowDialog_Bugs = room {
    nam = function (s)
        p ('Year '..Year..'. Sowing is canceled.');
    end,
    pic = function (s)
        return 'images/locust.png';
    end,
    dsc = function (s)
        return 'Sowing is canceled becouse of locust invasion.';
    end,
    obj = { vway('1', '{Next}', 'ShowScienceDialog') },
};


ShowSowDialog_Radiation = room {
--    nam = '«KoG» ShowSowDialog_Radiation',
    nam = function (s)
        p ('Year '..Year..'. Sowing is canceled.');
    end,
    pic = function (s)
        return 'images/locust.png';
    end,
    dsc = function (s)
        return 'Sowing is canceled becouse of high radiation level.';
    end,
    obj = { vway('1', '{Next}', 'ShowScienceDialog') },
};
