ShowPeaceTalkDialog = room {
    nam = function (s)
        p ('Year '..Year..'. Peace negotiations.');
    end,
    pic = 'images/rebellion.png',
    enter = function (s)
        if (result == 0) then
            return walk (BuildSomething_Sow);
        end
        TalkWait = 5;
        tmp = math.random();
        if (tmp<(0.75-Science.policy/100)) then
            return walk (ShowWarDeclareDialog);
        end
        if (sudden>0) then
            return walk (ShowWarDeclareDialog);
        end
        if (Igo or Monster) then
            return walk (ShowWarDeclareDialog);
        end
        v  = math.floor (Corn.now/3);
        qq = math.floor (Land.now/3);
        pp = math.floor (People.now/3);
    end,
    dsc = function (s)
        p ('Peace negotiations have started.');
        p ('^There will be no war, if you will give to an enemy a one third of your kingdom. In particular:');
        p ('^ - Grain: ', v, ' bushels;');
        p ('^ - Land: ', qq, ' acres;');
        p ('^ - People: ', pp, ' man.');
        p ('^Do you agree on this conditions?');
    end,
    obj = { vway('1', '{It is bargain!}^', 'main'), -- BuildSomething_Sow
            vway('2', '{No way!}', 'instruction') }, -- ShowWarDeclareDialog
    exit = function (s, to)
-- if false: ShowWarDeclareDialog; GoWar;
-- if true:  BuildSomething;
        if to == main then
            Corn.war = -v;
            Land.war = -qq;
            People.war = -pp;
            Corn.now = Corn.now + Corn.war;
            Land.now = Land.now + Land.war;
            People.now = People.now + People.war;
            if Rebel then
                Yoke = math.floor(Yoke/(1.1+(Science.policy+Science.people)/100));
            else
                Yoke = Yoke + math.floor (People.war/20-People.now/20);
            end
            return walk (BuildSomething_Sow);
        end
        if to == instruction then
            return walk (ShowWarDeclareDialog);
        end
    end,
};


ShowWarDeclareDialog = room {
    nam = function (s)
        p ('Year '..Year..'. Full mobilization.');
    end,
    pic = 'images/rebellion.png',
    enter = function (s)
-- qqq CHECK ALL ELSE IFs!
        if Rebel then
            tmp = math.random();
            Army1 = math.floor (People.now/(1.25+tmp*Science.people/10));
            People.now = People.now - Army1;
        elseif SeaWar then
            tmp = math.random(10);
            pp = math.random (math.floor(15+Science.war/2+Science.ships/2));
            Army1 = math.floor(People.sail + tmp - pp);
        elseif Igo then
            tmp = math.random();
            Army1 = math.floor (Year*(tmp*30+30));
        elseif Monster then
            tmp = math.random(1500);
            Army1 = 15000 + tmp;
            if isTower then
                tmp = math.random();
                Army1 = math.floor (Army1/(2 + tmp/10));
            end
        else
            tmp = math.random();
            Army1 = math.floor (Year*(tmp*10+(10-sudden/15)));
        end

        if (Army1 <=0 ) then
            Army1 = 1;
        end
        if SeaWar then
            Army = People.sail;
        else
            Army = math.floor (People.now/(2 - Science.war/20));
        end

        tmp = math.random();
        WinCorn = math.floor (Army1*100*(1+tmp*Science.war/10)/5);
        tmp = math.random();
        WinLand = math.floor (Army1*10*(1+tmp*Science.war/10)/5);

        if SeaWar then
            WinCorn = math.floor(WinCorn*(1+Science.ships/20)*2);
        end
        if Monster then
            WinCorn = 0;
            WinLand = 0;
        end
        if SeaWar then
            AllEnd = false;
            return walk (GoWar);
        end
        vvod._txt = '';
        vvod:act();

        enemy = 110 - Science.war * 10;
        tmp = math.random (2 * enemy);
        enemy = Army1 + tmp - enemy;
        if (enemy <= 0) then
            enemy = math.random(10);
        end
        tmp = math.random(20);
        v   = math.random(math.floor(Year/3));
        xmenprice = tmp + 70 + v;

        m = math.floor (Corn.now/xmenprice);

        tmp = math.random ();
        v   = math.random (10);
        pp = math.floor (10 + tmp * (Science.buy*1.25) - v);
        if (pp == 0) then
            pp = 1;
        end
    end,
    forcedsc = true;
    dsc = function (s)
        p ('Full mobilization is announced!');
        p ('^You have in army now: ', Army, ' warriors.');
        p ('^Proposal enemy army: ', enemy, ' warriors.');
        p ('^Every mercenary demand ', xmenprice, ' bushels of grain for a battle.');

        p ('^^Rest of your budget:');
        p ('^Grain: ', Corn.now, ' bushels.');
        p ('^Land: ', Land.now, ' acres.');
        p ('^Total you can hire: ', m, ' mercenaries for ', m*xmenprice, ' bushels of grain.');

        p ('^^In mobilization condition you can quickly sell land for ', pp, ' bushels/acre.');
        p ('^How much acres do you want to sell?');
    end,
    inp_enter = function()
        local a = 0;
        a = tonumber(vvod:text());
        if not a then
            p 'Error - this is not a number.';
            vvod:act();
            return;
        end
        if (a < 0) then
            a = 0;
        end
        if (a > Land.now) then
            p 'You have not that much land!';
            vvod:act();
            return;
        end
        if (not (a == 0)) then
            if (a > (Land.now-25)) then
                p 'Your people need to live somewhere!';
                vvod:act();
                return;
            end
        end
        Land.corn = Land.corn - a;
        Corn.land = Corn.land + a * pp;
        Land.now = Land.now - a;
        Corn.now = Corn.now + a * pp;

        return walk (ShowWarDeclareDialog_2);
    end,
    obj = { 'vvod' },
};


ShowWarDeclareDialog_2 = room {
    nam = function (s)
        p ('Year '..Year..'. Mercenaries.');
    end,
    pic = 'images/rebellion.png',
    enter = function (s)
        m = math.floor (Corn.now/xmenprice);
        vvod._txt = '';
        vvod:act();
    end,
    forcedsc = true;
    dsc = function (s)
        p ('^You have in army now: ', Army, ' warriors.');
        p ('^Proposal enemy army: ', enemy, ' warriors.');
        p ('^Every mercenary demand ', xmenprice, ' bushels of grain for a battle.');

        p ('^^Rest of your budget:');
        p ('^Grain: ', Corn.now, ' bushels.');
        p ('^Land: ', Land.now, ' acres.');
        p ('^Total you can hire: ', m, ' mercanries for ', m*xmenprice, ' bushels of grain.');
    end,
    inp_enter = function()
        local a = 0;
        a = tonumber(vvod:text());
        if not a then
            p 'Error - this is not a number.';
            vvod:act();
            return;
        end
        if (a < 0) then
            a = 0;
        end
        if (a > m) then
            p 'You have not that much grain!';
            vvod:act();
            return;
        end

        Corn.fee = a * xmenprice;
        Corn.now = Corn.now - Corn.fee;
        Army = Army + a;

        AllEnd = false;
        return walk (GoWar);
    end,
    obj = { 'vvod' },
};



GoWar = room {
    nam = function (s)
        p ('Year '..Year..'. Battle!');
    end,
    pic = 'images/city_attack.png',
    enter = function (s)
        warend = true;
        exist('2'):disable();
        if ( (TalkWait == 0) and (not Monster) ) then
            exist('2'):enable();
        else
            TalkWait = TalkWait - 1;
        end
    end,
    forcedsc = true;
    dsc = function (s)
        p ('You army: ', Army, ' warriors.');
        p ('^Enemy army: ', Army1, ' warriors.');
--        p ('^TALKWAIT: ', TalkWait);
    end,
    obj = { vway('1', '{Continue battle}', 'GoWar'),
            vway('2', '^{Send a messager}', 'ArmyGiveUp'):disable() },
    exit = function (s, to)
        if to == GoWar then
            tmp = math.random();
            p_tmp = math.random (10);
            a0 = Army - math.floor (Army1 / (10 + tmp) + p_tmp/2);
            tmp = math.random();
            p_tmp = math.random (5+Science.war);
            a1 = Army1 - math.floor(Army / (10 + tmp - Science.war/50) + p_tmp/2);
            Army = a0;
            Army1 = a1;
            if ( (Army>0) and (Army1>0)) then
                return walk (Army1GiveUp);
            end
            return walk (EndWar);
        end
    end,
};


ArmyGiveUp = room {
    nam = function (s)
        p ('Year '..Year..'. You send a messager.');
    end,
    pic = 'images/city_army_approach_messenger.png',
    enter = function (s)
        if Monster then
            return walk (GoWar);
        end
        TalkWait = 5;
    end,
    dsc = function (s)
        p ('You decide, that further struggle with the enemy is meaningless. You send a messager to an enemy camp with a latter about...');
    end,
    obj = { vway('1', '{...continuing of battle.}', 'GoWar'),
            vway('2', '^{...propose a armistice.}', 'main'),
            vway('3', '^{...paying contribution (a quarter of your kingdom) as a sign of defeat.}', 'instruction'),
            vway('4', '^{...Unconditional surrender of an enemy.}', 'ShowSowDialog_Bugs'), },
    exit = function (s, to)
        -- propose peace
        if to == main then
            tmp = math.random();
            pp = math.random();
            if ((Army1<(Army*(2+tmp/3))) and (pp>0.75)) then
                Army1 = 0;
                Yoke = Yoke - 5;
                AllEnd = true;
                warend = true;
                p 'Enemy taked your proposal.';
                return walk (EndWar);
            else
                p 'Enemy declined your proposal.';
                return walk (GoWar);
            end;
        end
        -- contribution
        if to == instruction then
            if Igo then
                return walk (GoWar);
            end
            tmp = math.random();
            if (tmp > 0.5) then
                Corn.war = - math.floor (Corn.now/4);
                Corn.now = Corn.now + Corn.war;
                Land.war = -math.floor (Land.now/4);
                Land.now = Land.now + Land.war;
                People.war = -math.floor (People.now/4);
                People.now = People.now + People.war;
                Yoke = Yoke + math.floor (-People.war/20-People.now/20);
                if SeaWar then
                    Ships.sail = 1;
                    People.sail = Army;
                end
                AllEnd = true;
                warend = true;
                p 'Enemy taked your proposal.';
                return walk (EndWar);
            else
                p 'Enemy declined your proposal.';
                return walk (GoWar);
            end
        end
        -- propose give up
        if to == ShowSowDialog_Bugs then
            if Igo then
                p 'Enemy declined your proposal.';
                return walk (GoWar);
            end
            tmp = math.random();
            pp = math.random();
            if ((Army1<(Army/(1+tmp/3)))and(pp>0.85)) then
                Yoke = Yoke - math.floor (Army/10);
                if not Rebel then
                    Corn.war = WinCorn;
                    Corn.now = Corn.now + Corn.war;
                    Land.war = WinLand;
                    Land.now = Land.now + Land.war;
                end
                People.war = Army1;
                People.now = People.now + People.war;
                Army1 = 0;
                AllEnd = true;
                warend = true;
                p 'Enemy taked your proposal.';
                return walk (EndWar);
            else
                p 'Enemy declined your proposal.';
                return walk (GoWar);
            end
        end
        -- end of propose give up
    end,
};


Army1GiveUp = room {
    nam = function (s)
        p ('Year '..Year..'. The messager has arrived to you.');
    end,
    pic = 'images/city_attack_messenger.png';
    enter = function (s)
        if Monster then
            return walk (GoWar);
        end
        tmp = math.random();
        if (Army<(Army1*(1.5+tmp*2))) then
            return walk (GoWar);
        end
        if (TalkWait > 0) then
            TalkWait = TalkWait - 1;
            return walk (GoWar);
        end
        if SeaWar then
            return walk (GoWar);
        end
        warend = false;
    end,
    dsc = function (s)
        p ('The messager of enemy Kingdom has arrive to your castle, carrying proposal of end the war.');
        p ('^What you will do?');
    end,
    obj = { vway('1', '{Continue battle.}', 'GoWar'),
            vway('2', '^{Propose a armistice.}', 'main'),
            vway('3', '^{Demand a contribution.}', 'instruction'),
            vway('4', '^{Hang a messager.}', 'ShowSowDialog_Bugs'), },
    exit = function (s, to)
        -- propose peace
        if to == main then
            Yoke = Yoke - math.floor (Army/20);
            Army1 = 0;
            AllEnd = true;
            warend = true;
            p 'Enemy taked your proposal.';
            return walk (EndWar);
        end
        -- demand contribution
        if to == instruction then
            tmp = math.random();
            if ( Army > (Army1 * (3 - tmp))) then
                Yoke = Yoke - math.floor (Army/5);
                if not Rebel then
                    Corn.war = math.floor (WinCorn/2);
                    Corn.now = Corn.now + Corn.war;
                    Land.war = math.floor (WinLand/2);
                    Land.now = Land.now + Land.war;
                end
                if SeaWar then
                    People.sail = People.sail + math.floor(Army1/2);
                else
                    People.war = Army1;
                    People.now = People.now + People.war;
                    Army1 = 0;
                end
                AllEnd= true;
                warend = true;
                p 'Enemy taked your proposal.';
                return walk (EndWar);
            else
                p 'Enemy declined your proposal.';
                return walk (GoWar);
            end
        end
        -- hang on a messenger
        if to == ShowSowDialog_Bugs then
            TalkWait = 100;
            return walk (GoWar);
        end
    end,
};


EndWar = room {
    nam = function (s)
        p ('Year '..Year..'.');
    end,
    pic = 'images/city_attack_messenger.png';
    enter = function (s)
        Igo = false;
        if Rebel then
            tmp = math.random (10);
            Yoke = Yoke - tmp;
        end
        if AllEnd then
            if SeaWar then
                Ships.now = Ships.now + Ships.sail;
                Ships.port = Ships.sail;
                Ships.sail = 0;
                People.now = People.now + People.sail;
                People.port = People.sail;
                People.sail = 0;
            end
            return walk (BuildSomething_Sow);
        end
        if (Army1 <= 0) then
            p 'You win the war!';
        else
            p 'You loose the war!';
        end
        if (Army1 < 0) then
            Army1 = 0;
        end
        if warend then
            if (Army1 == 0) then
                if not Rebel then
                    Corn.war = WinCorn;
                    Corn.now = Corn.now + Corn.war;
                    Land.war = WinLand;
                    Land.now = Land.now + Land.war;
                end
                if SeaWar then 
                    People.sail = Army;
                    Ships.war = math.random ( math.floor(2+Science.ships/10) );
--                    Ships.war = random(trunc(2+Science.ships/10));
                    Ships.sail = Ships.sail + Ships.war;
                else
                    People.war = math.floor (Army1/2);
                    People.now = People.now + People.war;
                end
                Yoke = Yoke - math.floor (People.now/25);
            else
                if SeaWar then
                    Ships.sail = 0;
                    People.sail = 0;
                elseif Igo then
                    Corn.war = - math.floor (Corn.now/1.25);
                    Corn.now = Corn.now + Corn.war;
                    Land.war = -math.floor (Land.now/1.25);
                    Land.now = Land.now + Land.war;
                    People.war = - math.floor (People.now/1.25);
                    People.now = People.now + People.war;
                elseif Monster then
                    Corn.war = -Corn.now;
                    Corn.now = 0;
                    Land.war = -Land.now;
                    Land.now = 0;
                    People.war = -People.now;
                    People.now = 0;
                    MegaMonster = 666;
                else
                    Corn.war = -math.floor(Corn.now/3);
                    Corn.now = Corn.now + Corn.war;
                    Land.war = -math.floor (Land.now/3);
                    Land.now = Land.now + Land.war;
                    People.war = -math.floor (People.now/3);
                    People.now = People.now + People.war;
                end
                Yoke = Yoke + math.floor (-People.war/10 + People.now/10);
            end
        end
        return walk (BuildSomething_Sow);
    end,
};
